﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ElFinder.Connector.Utils;
using System.Diagnostics;
using ICSharpCode.SharpZipLib.Zip;
using System.Collections;

namespace ElFinder.Connector.Commands
{
    public class Extract : ICommand
    {
        public string Current { get; set; }

        public string Target { get; set; }

        public Extract(string current, string target)
        {
            this.Current = current;

            this.Target = target;
        }

        #region ICommand Members

        public ElFinder.Connector.Responses.Response Execute()
        {
            var path = DirectoryUtils.GetRelativePathByHash(Current);
            var toExtract = DirectoryUtils.GetFilePathByHash(Target);

            FastZip fz = new FastZip();
            fz.ExtractZip(toExtract, path, null);

            var folder = new Utils.Folder(path);

            var response = new Responses.DirectoryResponse();

            response.cwd = folder.Cwd;

            response.cdc = folder.Contents;

            response.tree = folder.Tree;

            return response;
        }

        #endregion
    }
}
